/************************************************************************/
// PIDControl.c 
// PIDp֐Q
// 16bitPWM version
// 2006/11/15
// 2006n݌vTA ܏\W
// 2007/10/21
// 2007n݌vTA ֌a^
// 2008/10/16
// 2007n݌vTA tROM
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sfr26.h"
#include "PIDControl.h"	

/************************************************************************/
// O[oϐ`
/************************************************************************/
extern float sampling_time;        // TvO^C
float dx_d;				// ڕWx

/************************************************************************/
// ֐̃vg^Cv錾
/************************************************************************/
unsigned int Speed_lim(long);
void PID_control(int, float, int, float, unsigned char,
		 unsigned char _far*, unsigned int _far*,
		 int, int, int);

/****************************************************************************/
/*	֐Fvel_control                                                 */
/*	e  F葬xs                                            */
/*	      FxTFڕWʒuAspanFڕWBԁAinit_flag1FptO*/
/*	      FxFʒuAdxFxAKp,Ki,KdFPIDp[^                  */
/*	      Fcwccw_flagF[^]wtO                        */
/*	      FinputF[^ւPWM                                    */
/****************************************************************************/
void vel_control(int xT,  float span, unsigned char _far *init_flag1,
		 int x, float dx,
		 int Kp, int Ki, int Kd,
		 unsigned char _far *cwccw_flag, unsigned int _far *input)
{
  // ڕWO߂ۂ̃p[^
  static float t = 0.0;  // ԕϐ
  static int x0 = 0;     // ʒu

  int x_d;     // ڕWʒuO

  unsigned char tmp_cwccw_flag;
  unsigned int tmp_input;

  unsigned char init_flag2;
  init_flag2 = *init_flag1;

  ///////////////ۑ2-1/////////////////////////
  // 
  if(*init_flag1 == 0){
    x0 = x;
    t = 0.0;
    *init_flag1 = 1;
    dx_d = ;   //ڕWxvZ
  }

  /*-----------------------------------------------*/
  // ڕWOvZ
  /*-----------------------------------------------*/
  if(t <= span){
    t = t + sampling_time;
    
    x_d = ;
  }
  ///////////////ۑ2-1܂/////////////////
  
  /*-----------------------------------------------*/
  // ڕWOɑ΂PID
  /*-----------------------------------------------*/
  PID_control(x, dx, x_d, dx_d, init_flag2,
	      &tmp_cwccw_flag, &tmp_input,
	      Kp, Ki, Kd);
  *cwccw_flag = tmp_cwccw_flag;
  *input = tmp_input;
}

/***************************************************************************/
/*	֐FPID_Control                                                */
/*	e  FڕWʒuAxɑ΂PIDs                        */
/*	      FxFʒuAdxFxAx_dFڕWʒuAdx_dFڕWx           */
/*	      Finit_flagFptO                                  */
/*	      Fcwccw_flagF[^]wtO                       */
/*	      FinputF[^ւPWM                                   */
/*	      FKp,Ki,KdFPIDp[^                                    */
/***************************************************************************/
void PID_control(int x, float dx, int x_d, float dx_d, unsigned char init_flag,
		 unsigned char _far *cwccw_flag, unsigned int _far *input,
		 int Kp, int Ki, int Kd)
{
  float e;               // ʒu̕΍
  float de;              // x̕΍
  static float ie = 0.0; // ΍̐ϕl
  long tmp_input;        // ͗pԕϐ
  
  // ϕl
  if(init_flag == 0){
    ie = 0.0;
  }

  ///////////////ۑ2-1/////////////////////////
  /* ʒu̕΍eƂ */
  e = ; 	
  
  /* x̕΍deƂ */
  de = ;

  /* ΍ϕ */
  ie = ;
  
  ///////////////ۑ2-1܂/////////////////
  
  /* ͂߂ił́}ŏoĂj */
  tmp_input = (long)((float)Kd*de + (float)Kp*e + (float)Ki*ie);
  
  /* o͒loxffff𒴂ƃ}YĈŃ~bg */
  /* o͒l͐łȂ΂ȂȂ̂œ͂́}͉]tOőΉ */

  /* ] */
  if(tmp_input > 0){
    /* Ń~bg܂ */				
    *input = Speed_lim(tmp_input);
    *cwccw_flag = 0; //]M
  }
  /* t] */
  else {
    /*Ń~bg܂*/
    *input = Speed_lim(tmp_input);
    *cwccw_flag = 1; //t]M
  }

}


/***************************************************************************/
/*	֐FSpeed_lim(long)                                            */
/*	e  F[^[PWM̏100%ł邽߂Ń~bg܂  */
/*	      Fɕ̒l͐ɕϊ                                     */
/***************************************************************************/
unsigned int Speed_lim(long k){
  if(k > 0xfffe){
    return 0xfffe;
  }
  else if(k > 0){
    return k;
  }
  else if(k > -0xfffe){
    return (-k);
  }
  else {
    return 0xfffe;
  }
}

